# Hurricane Documentation

# Hurricane VLSI Database

List of all members | Public Types
Hurricane::Net::Direction Class Reference

## Public Types

enum | Code { DirIn = 0x0001, DirOut = 0x0002, DirUndefined = 0x0000, ConnTristate = 0x0100, ConnWiredOr = 0x0200, UNDEFINED = DirUndefined, IN = DirIn, OUT = DirOut, INOUT = DirIn | DirOut, TRISTATE = DirOut | ConnTristate, TRANSCV = DirIn | DirOut | ConnTristate, WOR_OUT = DirOut | ConnWiredOr, WOR_INOUT = DirIn | DirOut | ConnWiredOr }

## Detailed Description

Encapsulate the Net::Direction::Code enumeration that defines the signal direction. This direction is meaningful for external nets only.

## Member Enumeration Documentation

## ◆ Code

enum Hurricane::Net::Direction::Code

This enumeration defines the signal direction inside the Net::Direction. It is build upon two kind of atomic flags, one telling were the sources and sinks are located regarding the Cell and the other indicating the nature of the driver (normal, tristate, wired-or).

Enumerator
DirIn | There is at least one sink on this net (atomic).
DirOut | There is at least one source on this net (atomic).
DirUndefined | Undefined direction (atomic).
ConnTristate | The sources are tristates, this a bus (atomic).
ConnWiredOr | The sources are wired or, this a bus (atomic).
UNDEFINED | Undefined direction.
IN | There must be only sinks inside and a single permanent driver outside.
OUT | There must be no driver outside and a single permanent driver inside (and no sinks inside).
INOUT | There must be one permanent driver inside withs at least one sink inside.
TRISTATE | An OUT signal with a tristate driver (bus).
TRANSCV | An INOUT signal with a tristate driver (bus).
WOR_OUT | An OUT signal with a wired-or driver (bus).
WOR_INOUT | An INOUT signal with a wired-or driver (bus).

The documentation for this class was generated from the following files:

- Net.h
- Net.dox